'///////////////////////////////////////////////////////////////////////////////////////////
'//
'//                       Firefox Mini Profile Builder V4.0
'//                     for KoXo Profiles & KoXo Administrator
'//                        (C)2006-2016 KoXo Developpement      
'//
'///////////////////////////////////////////////////////////////////////////////////////////
'// Usage :
'// FFConf.vbs 
'//            /StoreFFProfileInMyPath:1 ...
'//            /AlwaysConfigure:1 ... 
'//            /PrivateBrowsing:1 ... 
'//            /MyPath:"P:\CONFIG\Firefox" ...
'//            /HomePage:"http://mypage" ...
'//            /SearchEngine:"Bing"
'//            /NoSearchEngines:"Amazon.fr,DuckDuckGo,eBay France,Portail Lexical - CNRTL,Wikipdia (fr)"
'//            /UseProxy:1 /Proxy:"192.168.1.1" /ProxyPort:"8080" ... or  /ProxyAutoConfigUrl:"http://srv/proxypac/myproxy.pac"
'//            (If ProxyAutoConfigUrl is defined, manual proxy parameters are ignored)
'//            /ProxyNoProxiesOn:"localhost,127.0.0.1" 
'// Example : 
'// FFConf.vbs /MyPath:"P:\Firefox" /StoreFFProfileInMyPath:1 /AlwaysConfigure:1 /HomePage:"http://mypage"
'// --> Save the FF profile in "P:\Firefox", use "http://mypage" as HomePage, and always updates "Prefs.js"
'//
'///////////////////////////////////////////////////////////////////////////////////////////
'//
'/// MAIN ///////////////////////////////////////////////////////////////////////////////////
'//
Dim StoreFFProfileInMyPath,MyPath,AlwaysConfigure,HomePage,PrivateBrowsing,SearchEngine,NoSearchEngines
Dim UseProxy,Proxy,ProxyPort,ProxyNoProxiesOn,ProxyAutoConfigUrl
Dim FFProfilePath,FFProfileListDir,FFProfileListFile,FFPrefs
SetDefaultValues()
GetCommandLine()
If StoreFFProfileInMyPath Then
   FFProfilePath=MyPath
   Else
   FFProfilePath=GetRoamingProfilePath & "\Mozilla\Firefox\Profile"
   End If
'Build profile folder
If Not DirectoryExists(FFProfilePath) Then
   ForceDirectories(FFProfilePath)
   End If
'Build FF roaming profile folder if necessary
FFProfileListDir=GetRoamingProfilePath & "\Mozilla\Firefox"
If Not DirectoryExists(FFProfileListDir) Then
   ForceDirectories(FFProfileListDir)
   End If
'Build FF local profile folder if necessary   
FFLocalProfileListDir=GetLocalProfilePath & "\Mozilla\Firefox\Profile"
If Not DirectoryExists(FFLocalProfileListDir) Then
   ForceDirectories(FFLocalProfileListDir)
   End If 
'Build "profiles.ini" each time
FFProfileListFile=FFProfileListDir & "\profiles.ini"
GenerateFFProfileList(FFProfileListFile)
'Build "prefs.js" or modify it if asked
FFPrefs=FFProfilePath & "\prefs.js"
If Not FileExists(FFPrefs) Then
   GenerateFFPrefs FFPrefs,HomePage,SearchEngine,NoSearchEngines,UseProxy,Proxy,ProxyPort,ProxyNoProxiesOn,ProxyAutoConfigUrl,FFLocalProfileListDir,PrivateBrowsing
   Else 
   If AlwaysConfigure Then 
      ModifyFFPrefs FFPrefs,HomePage,SearchEngine,NoSearchEngines,UseProxy,Proxy,ProxyPort,ProxyNoProxiesOn,ProxyAutoConfigUrl,FFLocalProfileListDir,PrivateBrowsing
      End If
   End If 
WScript.Quit
'// END MAIN ////////////////////////////////////////////////////////////////////////////////
'//
'///////////////////////////////////////////////////////////////////////////////////////////
'// Set Default values
Function SetDefaultValues()
'StoreFFProfileInMyPath -> 0=roaming profile is use to store FF profile
'                          1=specified folder is used to store FF profile  
StoreFFProfileInMyPath=0      
MyPath="P:\CONFIG\Firefox"
'AlwaysConfigure -> 0=user can modify proxy and homepage settings 
'                   1=proxy and homepage settinfs are configured each time
AlwaysConfigure=1
'Private Browsing
PrivateBrowsing=0
'Home page : use semicolon to add several home pages
HomePage="http://www.koxo.net/"
'Default Search Engine : Bing, Google, Yahoo ... 
SearchEngine="Bing"
'Search Engines not displayed
NoSearchEngines="Amazon.fr,DuckDuckGo,eBay France,Portail Lexical - CNRTL"
' UseProxy -> -1=do not configure the proxy -0=disable proxy 1=enable the proxy
UseProxy=0                 
Proxy="192.168.1.254"
' ProxyPort-> -1=do not configure the port >-1=configure the port with the value
ProxyPort=8080
ProxyNoProxiesOn="localhost,127.0.0.1,192.168.0.0/24"
ProxyAutoConfigUrl=""
End Function
'///////////////////////////////////////////////////////////////////////////////////////////
'// Command line options
Function GetCommandLine()
Dim S
If WScript.Arguments.Named.Count>0 Then
   S=WScript.Arguments.Named("StoreFFProfileInMyPath")
   If S<>"" Then 
      StoreFFProfileInMyPath=S 
      End If
   S=WScript.Arguments.Named("PrivateBrowsing")
   If S<>"" Then 
      PrivateBrowsing=S 
      End If
   S=WScript.Arguments.Named("MyPath")
   If S<>"" Then 
      MyPath=S 
      End If
   S=WScript.Arguments.Named("HomePage")
   If S<>"" Then 
      HomePage=S 
      End If
   S=WScript.Arguments.Named("SearchEngine")
   If S<>"" Then 
      SearchEngine=S 
      End If
   S=WScript.Arguments.Named("NoSearchEngines")
   If S<>"" Then 
      NoSearchEngines=S 
      End If
   S=WScript.Arguments.Named("UseProxy")
   If S<>"" Then 
      UseProxy=S 
      End If
   S=WScript.Arguments.Named("Proxy")
   If S<>"" Then 
      Proxy=S 
      End If
   S=WScript.Arguments.Named("ProxyPort")
   If S<>"" Then 
      ProxyPort=S 
      End If
   S=WScript.Arguments.Named("ProxyNoProxiesOn")
   If S<>"" Then 
      ProxyNoProxiesOn=S 
      End If
   S=WScript.Arguments.Named("ProxyAutoConfigUrl")
   If S<>"" Then 
      ProxyAutoConfigUrl=S 
      End If
   End If
End Function   
'///////////////////////////////////////////////////////////////////////////////////////////
'// Get Roaming Profile Path
Function GetRoamingProfilePath()
 Dim objShell
 Set objShell=CreateObject("WScript.Shell")
 GetRoamingProfilePath=objShell.ExpandEnvironmentStrings("%AppData%")
End Function
'///////////////////////////////////////////////////////////////////////////////////////////
'// Is legacy OS ?
Function IsWinV5()
Set objWMIService=GetObject("winmgmts:" _
 & "{impersonationLevel=impersonate}!\\.\root\cimv2")
Set colOSes = objWMIService.ExecQuery("Select * from Win32_OperatingSystem")
For Each objOS in colOSes
  IsWinV5=(objOS.Version<"6") 
Next
End Function
'///////////////////////////////////////////////////////////////////////////////////////////
'// Get Local Profile Path
Function GetLocalProfilePath()
 Dim objShell
 Set objShell=CreateObject("WScript.Shell")
 If IsWinV5 Then
    GetLocalProfilePath=objShell.ExpandEnvironmentStrings("%UserProfile%") 
    GetLocalProfilePath=GetLocalProfilePath & "\Local Settings\Application Data"
    Else GetLocalProfilePath=objShell.ExpandEnvironmentStrings("%LocalAppData%")
    End If
 'Local Settings\Application Data
End Function
'///////////////////////////////////////////////////////////////////////////////////////////
'// FileExists
Function FileExists(Filename)
Dim objFSO
Set objFSO=CreateObject("Scripting.FileSystemObject")
FileExists=objFSO.FileExists(Filename)
End Function
'///////////////////////////////////////////////////////////////////////////////////////////
'// DirectoryExists
Function DirectoryExists(Dirname)
Dim objFSO
Set objFSO=CreateObject("Scripting.FileSystemObject")
DirectoryExists=objFSO.FolderExists(Dirname)
End Function
'///////////////////////////////////////////////////////////////////////////////////////////
'// CreateDirectory
Function CreateDirectory(Dirname)
On Error Resume Next
Dim objFSO
Set objFSO=CreateObject("Scripting.FileSystemObject")
Set objScriptShell=CreateObject("WScript.Shell")
err.Number=0
CreateDirectory=objFSO.CreateFolder(Dirname)
If err.Number<>0 Then 
   objScriptShell.PopUp "CreateFolder : " & Dirname & vbCrLf & _ 
                        "Description : " & err.Description & vbCrLf & _ 
                        "Code : " & err.Number,5,"Erreur",64
   End If
End Function
'///////////////////////////////////////////////////////////////////////////////////////////
'// Generate Firefox Profile List
Function GenerateFFProfileList(Filename)
Dim objFSO,TextFile 
Set objFSO=CreateObject("Scripting.FileSystemObject")
Set TextFile=objFSO.OpenTextFile(Filename,2,True)
TextFile.WriteLine("[General]")
TextFile.WriteLine("StartWithLastProfile=0")
TextFile.WriteLine("")
TextFile.WriteLine("[Profile0]")
TextFile.WriteLine("Name=Firefox")
TextFile.WriteLine("IsRelative=0")
TextFile.WriteLine("Path=" & FFProfilePath)
TextFile.Close
End Function
'///////////////////////////////////////////////////////////////////////////////////////////
'// Modify a Firefox Prefs
Function ModifyFFPrefs(Filename,HomePage,SearchEngine,NoSearchEngines,UseProxy,Proxy,ProxyPort,ProxyNoProxiesOn,ProxyAutoConfigUrl,FFLocalProfileListDir,PrivateBrowsing)
Dim objFSO,TextFile,Contents1,Contents2
Set objFSO=CreateObject("Scripting.FileSystemObject")
Set TextFile=objFSO.OpenTextFile(Filename,1,True)
Contents1=Split(TextFile.ReadAll,vbCrLf)
TextFile.Close
Set TextFile=Nothing 
Contents2=Filter(Contents1,Chr(34)&"browser.startup.homepage"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"browser.shell.checkDefaultBrowser"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"browser.tabs.warnOnClose"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"browser.startup.homepage_override.mstone"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"browser.search.defaultenginename"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"browser.search.selectedEngine"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"browser.search.hiddenOneOffs"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"browser.privatebrowsing.autostart"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"browser.cache.disk.parent_directory"&Chr(34),False,vbTextCompare)
'Proxy
Contents2=Filter(Contents2,Chr(34)&"network.proxy.share_proxy_settings"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"network.proxy.type"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"network.proxy.ftp"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"network.proxy.ftp_port"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"network.proxy.http"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"network.proxy.http_port"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"network.proxy.socks"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"network.proxy.socks_port"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"network.proxy.ssl"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"network.proxy.ssl_port"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"network.proxy.no_proxies_on"&Chr(34),False,vbTextCompare)
Contents2=Filter(Contents2,Chr(34)&"network.proxy.autoconfig_url"&Chr(34),False,vbTextCompare)
'
Set TextFile=objFSO.OpenTextFile(Filename,2,True)
TextFile.Write Join(Contents2,vbCrLf)
TextFile.Close
GenerateFFPrefs Filename,HomePage,SearchEngine,NoSearchEngines,UseProxy,Proxy,ProxyPort,ProxyNoProxiesOn,ProxyAutoConfigUrl,FFLocalProfileListDir,PrivateBrowsing
End Function
'///////////////////////////////////////////////////////////////////////////////////////////
'// Convert an integer to boolean string
Function IntegerToBoolStr(Val)
If Val=0 Then 
   IntegerToBoolStr="false"
   Else IntegerToBoolStr="true"
   End If
End Function
'///////////////////////////////////////////////////////////////////////////////////////////
'// Generate a new Firefox Prefs
Function GenerateFFPrefs(Filename,HomePage,SearchEngine,NoSearchEngines,UseProxy,Proxy,ProxyPort,ProxyNoProxiesOn,ProxyAutoConfigUrl,CachePath,PrivateBrowsing)
Dim objFSO,TextFile,S
Dim ConfString,ConfInteger
Set objFSO=CreateObject("Scripting.FileSystemObject")
Set TextFile=objFSO.OpenTextFile(Filename,8,True)
ConfString="user_pref(##1##, ##2##);"
ConfInteger="user_pref(##1##, #2#);"
S="browser.shell.checkDefaultBrowser" 
S=Replace(Replace(Replace(ConfInteger,"#1#",S),"#2#","false"),"#",Chr(34))
TextFile.WriteLine(S)
S="browser.tabs.warnOnClose" 
S=Replace(Replace(Replace(ConfInteger,"#1#",S),"#2#","false"),"#",Chr(34))
TextFile.WriteLine(S)
S="browser.startup.homepage_override.mstone" 
S=Replace(Replace(Replace(ConfString,"#1#",S),"#2#","ignore"),"#",Chr(34))
TextFile.WriteLine(S)
S="browser.cache.disk.parent_directory"
S=Replace(Replace(Replace(ConfString,"#1#",S),"#2#",CachePath),"#",Chr(34))
TextFile.WriteLine(S)
If HomePage<>"" Then 
   S="browser.startup.homepage" 
   S=Replace(Replace(Replace(ConfString,"#1#",S),"#2#",HomePage),"#",Chr(34))
   TextFile.WriteLine(S)
   End If
If SearchEngine<>"" Then 
   S="browser.search.defaultenginename" 
   S=Replace(Replace(Replace(ConfString,"#1#",S),"#2#",SearchEngine),"#",Chr(34))
   TextFile.WriteLine(S)
   S="browser.search.selectedEngine" 
   S=Replace(Replace(Replace(ConfString,"#1#",S),"#2#",SearchEngine),"#",Chr(34))
   TextFile.WriteLine(S)
   End If
If NoSearchEngines<>"" Then 
   S="browser.search.hiddenOneOffs" 
   S=Replace(Replace(Replace(ConfString,"#1#",S),"#2#",NoSearchEngines),"#",Chr(34))
   TextFile.WriteLine(S)
   End If
If PrivateBrowsing>-1 Then    
   S="browser.privatebrowsing.autostart" 
   S=Replace(Replace(Replace(ConfInteger,"#1#",S),"#2#",IntegerToBoolStr(PrivateBrowsing)),"#",Chr(34))
   TextFile.WriteLine(S)
   End If
If UseProxy>-1 Then 
   S="network.proxy.type" 
   S=Replace(Replace(Replace(ConfInteger,"#1#",S),"#2#",UseProxy),"#",Chr(34))
   TextFile.WriteLine(S)
   End If
If Proxy<>"" Then 
   S="network.proxy.ftp" 
   S=Replace(Replace(Replace(ConfString,"#1#",S),"#2#",Proxy),"#",Chr(34))
   TextFile.WriteLine(S)
   S="network.proxy.http" 
   S=Replace(Replace(Replace(ConfString,"#1#",S),"#2#",Proxy),"#",Chr(34))
   TextFile.WriteLine(S)
   S="network.proxy.socks" 
   S=Replace(Replace(Replace(ConfString,"#1#",S),"#2#",Proxy),"#",Chr(34))
   TextFile.WriteLine(S)
   S="network.proxy.ssl" 
   S=Replace(Replace(Replace(ConfString,"#1#",S),"#2#",Proxy),"#",Chr(34))
   TextFile.WriteLine(S)
   End If
If ProxyPort>-1 Then 
   S="network.proxy.ftp_port" 
   S=Replace(Replace(Replace(ConfInteger,"#1#",S),"#2#",ProxyPort),"#",Chr(34))
   TextFile.WriteLine(S)
   S="network.proxy.http_port" 
   S=Replace(Replace(Replace(ConfInteger,"#1#",S),"#2#",ProxyPort),"#",Chr(34))
   TextFile.WriteLine(S)
   S="network.proxy.socks_port" 
   S=Replace(Replace(Replace(ConfInteger,"#1#",S),"#2#",ProxyPort),"#",Chr(34))
   TextFile.WriteLine(S)
   S="network.proxy.ssl_port" 
   S=Replace(Replace(Replace(ConfInteger,"#1#",S),"#2#",ProxyPort),"#",Chr(34))
   TextFile.WriteLine(S)
   End If
If ProxyAutoConfigUrl<>"" Then 
   S="network.proxy.type" 
   S=Replace(Replace(Replace(ConfInteger,"#1#",S),"#2#",2),"#",Chr(34))
   TextFile.WriteLine(S)
   S="network.proxy.autoconfig_url" 
   S=Replace(Replace(Replace(ConfString,"#1#",S),"#2#",ProxyAutoConfigUrl),"#",Chr(34))
   TextFile.WriteLine(S)
   End If
If ProxyNoProxiesOn>-1 Then 
   S="network.proxy.no_proxies_on" 
   S=Replace(Replace(Replace(ConfString,"#1#",S),"#2#",ProxyNoProxiesOn),"#",Chr(34))
   TextFile.WriteLine(S)
   End If
S="network.proxy.share_proxy_settings" 
S=Replace(Replace(Replace(ConfInteger,"#1#",S),"#2#","true"),"#",Chr(34))
TextFile.WriteLine(S)
TextFile.Close
End Function
'///////////////////////////////////////////////////////////////////////////////////////////
'// ForceDirectories
Function ForceDirectories(Dirname)
Dim objFSO,Dir,X
Set objFSO=CreateObject("Scripting.FileSystemObject")
Dir=Dirname
If (Dir="") Then 
   Exit Function
   End If
If ((Len(Dir)<3) Or DirectoryExists(Dir)) Then 
   Exit Function
   End If
If Mid(Dir,1,Len(Dir))="\" Then 
   Dir=Mid(Dir,1,Len(Dir)-1) 
   End If
X=InStrRev(Dir,"\") 
ForceDirectories(Mid(Dir,1,X-1))
CreateDirectory(Dir)
End Function
'///////////////////////////////////////////////////////////////////////////////////////////